"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.babelTransform = babelTransform;
exports.getTransformValue = void 0;

var _standalone = require("@babel/standalone");

function babelTransform(input, filename) {
  return (0, _standalone.transform)(input, {
    filename: filename,
    presets: ['env', 'es2015', 'react', 'typescript']
  });
}

var getTransformValue = function getTransformValue(str, filename, funName) {
  var isReact = /import\x20+React(\x20+|[\x20+,]+({[a-zA-Z0-9,\s]+}|{})\x20+)from\x20+('|")react('|")/.test(str); // 先判断 是否引入 react

  var tran = isReact ? str : "import React from \"react\"\n ".concat(str);
  /** 先把默认导出 export default 进行替换 **/

  var newCode = "".concat(tran.replace(/export\x20+default/, 'const _default = '), "\n");
  var code = "".concat(babelTransform(newCode, "".concat(filename)).code, "\n return _react[\"default\"].createElement(_default)");
  return "function ".concat(funName, "(){\n    ").concat(code, "\n  }");
};

exports.getTransformValue = getTransformValue;
//# sourceMappingURL=transform.js.map